#pragma once

#include "fs/devices/Device.h"
#include <luna/SharedPtr.h>
#include <sys/types.h>

namespace DeviceRegistry
{
    enum DeviceMajorTypes : u32
    {
        Null = 0,
        Console = 1,
        Memory = 2,
        Framebuffer = 3,
        Disk = 4,
    };

    Result<SharedPtr<Device>> fetch_special_device(u32 major, u32 minor);

    Result<void> register_special_device(u32 major, u32 minor, SharedPtr<Device> device, const char* name,
                                         mode_t mode = 0666);

    Result<void> init();
}
